    
from PyQt5 import QtGui, QtCore
#from drivers.andorzyla import AndorZyla
#from drivers.andorzyla import AndorZyla
from drivers.dummyAndor import AndorZyla

from cameraGui import CameraGuiMainWindow
from zylaCameraWorker import CameraWorker
#from measurement import MeasurementWorker, MeasurementGui
from MCDAQcontrolsignals import anal_control_signal
from MCDAQcontrolsignals import digital_control_signal
from controlGui import ControlGui


if __name__ == "__main__":
    import sys
    app = QtGui.QApplication([])
    
    camera = AndorZyla(0)
    
    piezoA397 = anal_control_signal('piezoA397', channel=0, ao_type='cavity_piezo', out_minimum = 0, out_maximum = 4)
    piezoB397 = anal_control_signal('piezoB397', channel=1, ao_type='cavity_piezo')
    piezoA866 = anal_control_signal('piezoA866', channel=2, ao_type='cavity_piezo', out_minimum = 0, out_maximum = 4)
    piezoB866 = anal_control_signal('piezoB866', channel=3, ao_type='cavity_piezo')
    piezo423 = anal_control_signal('piezo423', channel=4, ao_type='laser_piezo')
    
    trapDCA = anal_control_signal('dcA', channel = 5, ao_type='electrode')
    trapDCB = anal_control_signal('dcB', channel = 6, ao_type='electrode')
    trapCOMPC = anal_control_signal('compC', channel = 7, ao_type='electrode')
    trapCOMPD = anal_control_signal('compD', channel = 8, ao_type='electrode')
    trapOven = anal_control_signal('compOven', channel = 9, ao_type='electrode')
    trapExYb = anal_control_signal('compExYb', channel = 10, ao_type='electrode')


    shutter866 = digital_control_signal('shutter866', channel = 0)
    shutter397 = digital_control_signal('shutter397', channel = 1)
    shutter423 = digital_control_signal('shutter423', channel = 2)
    shutter866WM = digital_control_signal('shutter866WM', channel = 3)

    controlGui = ControlGui()
    mcDAQthread = QtCore.QThread()

    for ao in anal_control_signal._registry:
        controlGui.make_connections(ao)
        ao.make_connections(controlGui)
        ao.moveToThread(mcDAQthread)
        ao.scanTimer.moveToThread(mcDAQthread)
        ao.scanTimer.timeout.connect(ao.scan_event)
    for do in digital_control_signal._registry:
        do.make_connections(controlGui)
        do.moveToThread(mcDAQthread)


    myGuiMainWindow = CameraGuiMainWindow()
    cameraWorker = CameraWorker(camera)

    cameraThread = QtCore.QThread()
    cameraWorker.moveToThread(cameraThread)

    cameraWorker.make_connections(myGuiMainWindow)
    myGuiMainWindow.make_connections(cameraWorker)

    cameraThread.start()
    mcDAQthread.start()

    sys.exit(app.exec_())
